//******************************************************************************
// *
// *       XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
// *       AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
// *       SOLUTIONS FOR XILINX DEVICES. BY PROVIDING THIS DESIGN, CODE,
// *       OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
// *       APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
// *       THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
// *       AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
// *       FOR YOUR IMPLEMENTATION. XILINX EXPRESSLY DISCLAIMS ANY
// *       WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
// *       IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
// *       REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
// *       INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// *       FOR A PARTICULAR PURPOSE.
// *
// *		Copyright(C) 2005 by xilinx, Inc. All rights reserved.              
// *
// *       (c) Copyright 2007 Xilinx Inc.
// *       All rights reserved.
//*
// ******************************************************************************/
// intrface.h
// Define an Interface Guid for xilinxdd device class.
// This GUID is used to register (IoRegisterDeviceInterface)
// an instance of an interface so that user application
// can control the xilinxdd device.
//
//{0A7972A5-04BF-4ec8-ADFA-F12EC65532AD}
DEFINE_GUID(GUID_DEVINTERFACE_XILINXDD,
    0x0A7972A5, 0x04BF, 0x4ec8, 0xAD, 0xFA, 0xF1, 0x2E, 0xC6, 0x55, 0x32, 0xAD);

// GUID definition are required to be outside of header inclusion pragma to avoid
// error during precompiled headers.
//

#ifndef __INTRFACE_H__
#define __INTRFACE_H__

#define FILE_DEVICE_XILINXDD  0x8000

// Define Interface reference/dereference routines for
// Interfaces exported by IRP_MN_QUERY_INTERFACE

#define XILINXDD_IOCTL(index) \
    CTL_CODE(FILE_DEVICE_XILINXDD, index, METHOD_BUFFERED, FILE_READ_DATA)


#define IOCTL_GET_CONFIG \
    CTL_CODE(FILE_DEVICE_XILINXDD, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_RESET_DEVICE \
    CTL_CODE(FILE_DEVICE_XILINXDD, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_RESET_PIPE \
    CTL_CODE(FILE_DEVICE_XILINXDD, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#endif // __INTRFACE_H__
